% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DCS_Methods.R
\name{summary.dcs_options}
\alias{summary.dcs_options}
\title{Print and Summarize Options for Double Conditional Smoothing}
\usage{
\method{summary}{dcs_options}(object, ...)
}
\arguments{
\item{object}{an object of class "dcs_options", usually, a result of a call
to \code{\link{set.options}}.}

\item{...}{Additional arguments passed to \code{summary.dcs_options}.}
}
\value{
No return value.
}
\description{
\code{summary} method for class \code{"dcs_options"}
}
\section{Details}{

\code{print.dcs_options} prints the main options and 
\code{summary.dcs_options} prints main and advanced (IPI) options used for
the \code{\link{dcs}} function. Arguments should be an object of class
\code{"dcs_options"}.
}

\examples{
## Default options
myOpt <- set.options()
print(myOpt)
summary(myOpt)

## Use Kernel regression
myOpt <- set.options(type = "KR")
print(myOpt)
summary(myOpt)

}
\seealso{
\code{\link{print.dcs}}, \code{\link{print.dcs_options}}
}
